datablock TSShapeConstructor(AvengerTurretDts)
{
	baseShape  = "./Avengerturret.dts";
	sequence0  = "./a_root.dsq root";

	sequence1  = "./a_root.dsq run";
	sequence2  = "./a_root.dsq walk";
	sequence3  = "./a_root.dsq back";
	sequence4  = "./a_root.dsq side";

	sequence5  = "./a_root.dsq crouch";
	sequence6  = "./a_root.dsq crouchRun";
	sequence7  = "./a_root.dsq crouchBack";
	sequence8  = "./a_root.dsq crouchSide";

	sequence9  = "./a_look.dsq look";
	sequence10 = "./a_root.dsq headside";
	sequence11 = "./a_root.dsq headUp";

	sequence12 = "./a_root.dsq jump";
	sequence13 = "./a_root.dsq standjump";
	sequence14 = "./a_root.dsq fall";
	sequence15 = "./a_root.dsq land";

	sequence16 = "./a_root.dsq armAttack";
	sequence17 = "./a_root.dsq armReadyLeft";
	sequence18 = "./a_root.dsq armReadyRight";
	sequence19 = "./a_root.dsq armReadyBoth";
	sequence20 = "./a_root.dsq spearready";  
	sequence21 = "./a_root.dsq spearThrow";

	sequence22 = "./a_root.dsq talk";  

	sequence23 = "./a_root.dsq death1"; 
	
	sequence24 = "./a_root.dsq shiftUp";
	sequence25 = "./a_root.dsq shiftDown";
	sequence26 = "./a_root.dsq shiftAway";
	sequence27 = "./a_root.dsq shiftTo";
	sequence28 = "./a_root.dsq shiftLeft";
	sequence29 = "./a_root.dsq shiftRight";
	sequence30 = "./a_root.dsq rotCW";
	sequence31 = "./a_root.dsq rotCCW";

	sequence32 = "./a_root.dsq undo";
	sequence33 = "./a_root.dsq plant";

	sequence34 = "./a_root.dsq sit";

	sequence35 = "./a_root.dsq wrench";
};    



datablock PlayerData(AvengerTurretPlayer)
{
ShootOnClickAvengerGun=1;
shootonclickAvengerGun_Hold=1;
shootonclickAvengerGun_ShootDelay=100;
shootonclickAvengerGun_ReShootDelay=100;
shootonclickAvengerGun_ProjectileCount=1;
shootonclickAvengerGun_RequiredSlot=0;
shootonclickAvengerGun_Sound=thirtycalShot1Sound;

shootonclickAvengergun_Projectile[0]=gunProjectile;
shootonclickAvengergun_Position[0]="0 0 2";
shootonclickAvengergun_Velocity[0]="200 0 0";
shootonclickAvengergun_Scale[0]="0.5 2 0.5";



   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./Avengerturret.dts";
   cameraMaxDist = 4;
   cameraTilt = 0;
   cameraVerticalOffset = 2;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 10.0;

   mass = 90;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 28 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 12;
   maxBackwardSpeed = 6;
   maxSideSpeed = 1;

   maxForwardCrouchSpeed = 12;
   maxBackwardCrouchSpeed = 6;
   maxSideCrouchSpeed = 1;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 17 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2.5 2.5 1.7", 4); 
   crouchBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 
   proneBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
	
   jetEmitter = playerJetEmitter;
   jetGroundEmitter = playerJetGroundEmitter;
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= HorseJumpSound;

   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	//uiName = "Avenger Turret";
	rideable = true;
   lookUpLimit = 0.7;
   lookDownLimit = 0.5;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = false;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};
datablock AudioProfile(AvengerbombSound)
{
   filename    = "./bombhatch.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(AvengeridleSound)
{
   filename    = "./idle.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};


datablock AudioProfile(Avengerthrottle1Sound)
{
   filename    = "./fly.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};


exec("add-ons/vehicle_spitfirestrat/server.cs");
exec("add-ons/vehicle_b17/server.cs");

datablock WheeledVehicleSpring(AvengerSpring)
{
   // Wheel suspension properties
   length = 0.4;        // Suspension trave
   force = 3000;        // Spring force
   damping = 2000;      // Spring damping
   antiSwayForce = 6;   // Lateral anti-sway force
};

datablock WheeledVehicleTire(AvengerTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "add-ons/vehicle_spitfirestrat/spitfirewheel.dts";
	
	mass = 100;
   radius = 1;
   staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 13000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(AvengerSpring)
{
   // Wheel suspension properties
   length = 0.4;        // Suspension trave
   force = 2000;        // Spring force
   damping = 2000;      // Spring damping
   antiSwayForce = 6;   // Lateral anti-sway force
};
datablock WheeledVehicleTire(AvengerrearTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.			
   shapeFile = "add-ons/vehicle_spitfirestrat/Spitfirerear.dts";
	
	mass = 10;
   radius = 1;
   staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 13000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(AvengerrearSpring)
{
   // Wheel suspension properties
   length = 0.4;        // Suspension trave
   force = 200;        // Spring force
   damping = 200;      // Spring damping
   antiSwayForce = 2;   // Lateral anti-sway force
};




datablock WheeledVehicleData(AvengerVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./Avenger2.dts"; //"~/data/shapes/skivehicle.dts"; //

	emap = true;
	minMountDist = 3;
   
   numMountPoints = 2;
   mountThread[0] = "sit";
      mountThread[1] = "sit";

shootonclickAvenger=1;
	 
shootonclickAvenger_Hold=1;
shootonclickAvenger_ShootDelay=1000;
shootonclickAvenger_ReShootDelay=1000;
shootonclickAvenger_ProjectileCount=1;
shootonclickAvenger_RequiredSlot=0;
shootonclickAvenger_Sound=AvengerbombSound;

shootonclickAvenger_Projectile[0]=bombProjectile;
shootonclickAvenger_Position[0]="-2 0 -4";
shootonclickAvenger_Velocity[0]="30 0 -29";
shootonclickAvenger_Scale[0]=".8 .8 .8 ";





	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 50.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";

	maxSteeringAngle = 1.2;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 23;         // Far distance from vehicle
	cameraOffset = 5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.2;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = true;	//exec("add-ons/vehicle_Avenger/vehicle_Avenger.cs");

	defaultTire	  = AvengerTire;
	defaultSpring = AvengerSpring;
	//flatTire	     = AvengerFlatTire;
	//flatSpring	  = AvengerFlatSpring;

   numWheels = 3;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 400; //4000;       // Engine power
	engineBrake = 300;         // Braking when throttle is 0
	brakeTorque = 3000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed


	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 2000;
	reverseThrust		= 20;
	lift			= 10;
	maxForwardVel		= 30;
	maxReverseVel		= 20;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 8000;
	yawForce		= 8000;
	pitchForce		= 8000;
	rotationalDrag		= 0.5;
	stallSpeed		= 5;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Avenger";
	rideable = true;
		lookUpLimit = 0.5;
		lookDownLimit = 0.5;

	paintable = true;
   damageEmitter[0] = LightDamageEmitter; 
   	damageEmitterOffset[0] = "0.0 3.0 0.5 ";
		damageLevelTolerance[0] = 0.35;
	
damageEmitter[1] = HeavyDamageEmitter; 
	damageEmitterOffset[1] = "0.0 3.0 0.0 ";
		damageLevelTolerance[1] = 0.7;
	
	
   damageEmitter[2] = VehicleBurnEmitter;
	damageEmitterOffset[2] = "0.0 0.0 0.0 ";
	damageLevelTolerance[2] = 0.99;

   damageEmitter[3] = VehicleBurnEmitter;
	damageEmitterOffset[3] = "0.0 0.0 0.0 ";
	damageLevelTolerance[3] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = jeepExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = AvengerFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minAvengerSpeed = 20;
   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   steeringUseStrafeSteering = false; //this vehicle has pitch control, so we can't use strafe steering
};


function Avengervehicle::onadd(%this,%obj)
{ 
	parent::onadd(%this,%obj);
			   %obj.playThread(0,"spin");
			   	AvengerSpeedCheck(%this, %obj);
	%obj.setWheelTire(0, Avengertire);
	%obj.setWheelTire(1, Avengertire);
	%obj.setWheelTire(2, Avengerreartire);

		%obj.setWheelSpring(0, AvengerSpring);
		%obj.setWheelSpring(1, AvengerSpring);
		%obj.setWheelSpring(2, AvengerSpring);
	
	%obj.setWheelSteering(0,0);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,-1);

	%obj.setWheelPowered(0,false);
  %obj.setWheelPowered(1,false);
	%obj.setWheelPowered(2,false);
		 %t = new AIPlayer()
 {
     dataBlock = AvengerTurretPlayer;
 };
 MissionCleanup.add(%t);
 %obj.mountObject(%t, 1);
%obj.turret = %t;
%obj.creationTime = getSimTime();
%t.schedule(10,"rigTurret");
}

function AvengerVehicle::onImpact(%this,%obj,%data)
{
	%speed = vectorLen(%obj.getVelocity());
	if(%speed > %obj.dataBlock.minAvengerSpeed)

		%trans = %obj.getTransform();

	%p = new Projectile()
	{
		dataBlock = AvengerFinalExplosionProjectile;
		initialVelocity  = "0 0 0";
		initialPosition  = %trans;
		sourceObject     = %obj;
		sourceSlot       = 0;
		client           = %obj.client;
	};
	MissionCleanup.add(%p);
	         if(%obj.destroyed)
            return;
         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(10,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");


}
datablock ExplosionData(AvengerFinalExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleFinalExplosionEmitter3;
   emitter[1] = vehicleFinalExplosionEmitter2;

   particleEmitter = vehicleFinalExplosionEmitter;
   particleDensity = 20;
   particleRadius = 1.0;


   faceViewer     = true;
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   damageRadius = 12;
   radiusDamage = 250;

   //burn the players?
   playerBurnTime = 5000;

};
datablock ProjectileData(AvengerFinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = AvengerFinalExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};

function AvengerSpeedCheck(%this, %obj)
{


	if(!isObject(%obj))
		return;

	%vehicle = %obj;
%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;

	if(%speed < 10)
	    %vehicle.playAudio(%slot, AvengeridleSound);

	else if(%speed < 30)
	    %vehicle.playAudio(%slot, Avengerthrottle1Sound);




	    

	schedule(500,0,"AvengerSpeedCheck",%this,%obj);
}

function Player::rigTurret(%obj)
{
   if(%obj.dataBlock !$= avengerTurretPlayer)
	   return;

   if(!isObject(%obj))
	   return;

   %parent = %obj.getObjectMount();
   if(!isObject(%parent))
	   return;

   %obj.spawnBrick = %parent.spawnBrick;
   %obj.brickGroup = %parent.brickGroup;
}

function avengerVehicle::onRemove(%this,%obj)
{
   if(isObject(%obj.turret))
	   %obj.turret.delete();

}

function avengerTurretPlayer::onDriverLeave(%this,%obj)
{
   %obj.setTransform("0 0 0 0 0 0 0");
}

package avengerPackage
{
   function Player::burn(%obj,%time)
   {
      if(%obj.dataBlock $= avengerTurretPlayer)
         return;
      else
         Parent::burn(%obj,%time);
   }

   function ShapeBase::setNodeColor(%obj,%node,%color)
   {
      Parent::setnodecolor(%obj,%node,%color);
      if(isObject(%obj.turret))
      {
        %obj.turret.setNodeColor("ALL","0.7 0.7 0.7 1");
     }

   }

   function avengerVehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      if((%obj.getDamageLevel()+%amm) >= %this.maxDamage)
      {
         if(%obj.destroyed)
            return;

         %obj.setNodeColor("ALL","0 0 0 1");
         if(isObject(%obj.turret))
         {
            %obj.turret.delete();
            %p = new Projectile()
            {
               dataBlock = avengerTurretExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         else
         {
            %p = new Projectile()
            {
               dataBlock = avengerExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         if(%obj.destroyed)
            return;

         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(%this.burnTime,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
      }
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function Player::emote(%obj,%emote)
   {
      if(%obj.dataBlock $= avengerTurretPlayer)
	      return;
      Parent::emote(%obj,%emote);
   }

   function avengerTurretPlayer::onDamage(%this,%obj,%ammount)
   {
      if(%obj.dataBlock $= avengerTurretPlayer)
         return;
	   Parent::onDamage(%this,%obj,%ammount);
   }

   function avengerShellProjectile::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e)
   {
      if(%col.dataBlock.className $= "Glass" && !%col.indestructable)
      {
         %col.explode();
      }
      Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e);
   }

   function avengerTurretPlayer::onDisabled(%this,%obj,%state)
   {
      %p = new Projectile()
      {
         dataBlock = avengerTurretExplosionProjectile;
         initialPosition = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
         initialVelocity = "0 0 1";
         client = %obj.lastDamageClient;
         sourceClient = %obj.lastDamageClient;
      };
      MissionCleanup.add(%p);
      %obj.schedule(10,"delete");
      %player = %obj.getMountedObject(0);
      if(isObject(%player))
      {
         %obj.getObjectMount().schedule(10,"mountObject",%player,1);
      }
   }

   function avengerTurretPlayer::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      //scale the damage ammount as if this was a vehicle
      %amm *= $Damage::VehicleDamageScale[%type];

      if(%obj.getDamageLevel()+%amm > %this.maxDamage)
         %obj.setDamageLevel(%this.maxDamage);
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this,%obj,%col,%slot);
      if(%col.getDataBlock() == avengerVehicle.getId())
      {
         if(%slot $= 1)
         {
            %obj.setLookLimits(1,0);
	%obj.setscale("1 1 1");
         }

		 
      }
      else if(%col.getDataBlock() == avengerTurretPlayer.getId())
      {
         %client = %obj.client;
         if(isObject(%client))
            ServerCmdUnUseTool(%client);
			%obj.setscale(".1 .1 .1");
      }
   }

   function Armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      if(%triggerNum $= 4)
      {
         if(%obj.getObjectMount().getDatablock() $= Avengerturretplayer.getID())
         {

            %obj.setScale("1 1 1");
         }
      }
      parent::onTrigger(%this, %obj, %triggerNum, %val);
   }
};
activatepackage(avengerPackage);
